program ex1b

  use pgmio

  implicit none

  include 'shmem.fh'
  
  integer, parameter :: nx = 360
  integer, parameter :: ny = 240

  integer, parameter :: numpes = 8

  integer, parameter :: nxlocal = nx
  integer, parameter :: nylocal = ny/numpes

  integer :: mype

  double precision, save :: bigpic(nx, ny)

  call shmem_init();
  
  mype = shmem_my_pe()

  if (numpes /= shmem_n_pes()) then

    if (mype == 0) then
      write(*,*) 'Error: compiled for ', numpes, &
                 ' PE(s), but running on ', shmem_n_pes()
    end if

    call shmem_finalize()

    stop

  end if

  if (mype == 0)  write(*,*) 'Running on ', numpes, ' PE(s)'

  write(*,*) 'Hello from PE ', mype, ' out of ', numpes

  bigpic(:,:) = -1.0

! In this incomplete template, just write picture out

  if (mype == 0) then

    call pgmwrite('output.pgm', bigpic)

  end if

  call shmem_finalize()

end program ex1b
